﻿# Optimierung-tiefensuche-tiefe-Liste.py
# rekursives Programm zum Füllen eines Containers mit Tiefensuche
# In diesem Fall wird die optimale Füllung gesucht


# Globale Variable für die Stücke:
##stuecke=[30,30,30,30,30,20,20,20,20,20]
# Beispiel, das nicht voll geht:
stuecke=[20, 20, 14, 14, 14, 11, 8, 8]
def erzeuge_Container(fassungsvermoegen):
    return [fassungsvermoegen, []]

def fuelle_ein(stueck, container):
    fuellung=[]+container[1] # echte Kopie erzeugen!
    fuellung.append(stueck)
    return [container[0], fuellung]

# Prädikat zum Testen, ob der Container voll ist.
def ist_voll(container):
    return container[0]==sum(container[1])

def wird_zu_voll(stueck, container):
    return container[0]<stueck+sum(container[1])

def inhalt(container):
    return sum(container[1])

def fuelle(stuecke, container, bester):
    ##input(str((stuecke,container,bester))) ## zum Verfolgen des Ablaufs
    print(stuecke,container,bester)
    if ist_voll(container):
        return container
    if len(stuecke)==0:
        return bester
    if wird_zu_voll(stuecke[0], container):
        return False
    ## Verwaltung fuer die Bestensuche:
    neu=fuelle_ein(stuecke[0], container)
    if inhalt(neu)>inhalt(bester):
        bester=neu
    ## weiter die eigentliche Suchfunktion
    ergebnis=fuelle(stuecke[1:],neu, bester)
    if ergebnis:
        return ergebnis
    else:
        return fuelle(stuecke[1:], container, bester)


### Tests
def ausgabe(stuecke, fassungsvermoegen):
    print('Stücke:', stuecke, fassungsvermoegen)
    bester=fuelle(stuecke,[fassungsvermoegen, []],[fassungsvermoegen, []])
    print('Ergebnis:\n', bester,
          'Füllung mit',inhalt(bester),'\n')


ausgabe( stuecke, 80)
##ausgabe( stuecke, 90)
##ausgabe( stuecke, 100)
##ausgabe( stuecke*10, 100)
##ausgabe( stuecke*10, 1000)
##ausgabe( [30,30,20,20], 50)
