﻿# Optimierung.py
# Programm zum optimalen Füllen eines Containers
#              =========
# basiert auf fuelle-iterativ-HGT

# Globale Variable für die Stücke wird hier zufällig generiert
import random
##stuecke=[]
##for i in range(8):
##    stuecke.append(5+3*random.randint(1,5))
##stuecke.sort(reverse=True)
# Beispiel, das nicht voll geht:
stuecke=[20, 20, 14, 14, 14, 11, 8, 8]
# zum Testen mit wenigen Stücken
##stuecke=[70,30,25,20,18,13]

# Prädikat zum Testen, ob der Container voll ist.
def istVoll(container, fassungsvermoegen):
    return fassungsvermoegen==sum(container)

def istZuVoll(container, fassungsvermoegen):
    return fassungsvermoegen<sum(container)

# mögliche Hilfsfunktion, eigentlich unnötig
def inhalt(container):
    return sum(container)

def fuelle(stuecke, fassungsvermoegen):
    alternativen=[]
    beste=[]
    # Alternativen sind: rein oder nicht rein
    for stueck in stuecke:
        print(alternativen,'\n')
        if alternativen==[]:
            alternativen=[[stuecke[0]],[]]
        else:
            temp=[]
            for alt in alternativen:
                if istVoll(alt+[stueck], fassungsvermoegen):
                    print('voll:')
                    return alt+[stueck]
                if istZuVoll(alt+[stueck], fassungsvermoegen):
                    temp+=[alt]
                else:
                    neu=alt+[stueck]
                    if sum(neu)>sum(beste):
                        beste=neu
                    temp+=[neu,alt]
            alternativen=temp
    print('beste Füllung: ',beste, sum(beste))
    return beste

print('Stücke: ', stuecke, 'Größe: ', 80 )
fuelle(stuecke, 80)
